
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JAVA基础学习day24--Socket基础一UDP与TCP的基本使用 / 憋错料</title>

    <meta name="description" content="JAVA基础学习day24--Socket基础一UDP与TCP的基本使用 一.网络模型 1.1.OIS参考模型 1.2.TCP/IP参考模型 1.3.网络通讯要素 IP地址:IPV4/IPV6 端口号:0-65535,一般0-1024,都被系统占用,mysql:3306,oracle:1521 传输协议:TCP/UDP 二.类 InetAddress 2.1.InetAddress 主机对象 IP 地址是 IP 使用的 32 位或 128 位无符号数字,它是一种低级协议,UDP 和 TCP 协议都是在它的基础上构建的 2.2.示例 import java.net.*;">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">JAVA基础学习day24--Socket基础一UDP与TCP的基本使用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1><strong>一、网络模型</strong></h1>
<p><strong>1.1、OIS参考模型</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTcwNzQ0NTg1LTg1NDQ0NDE2Mi5wbmc=.jpg" /></strong></p>
<p><strong>1.2、TCP/IP参考模型</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTcwODA5ODM1LTc4MzI0MTQyOC5wbmc=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTcwODE4NzI2LTE4MDc0MTcyMTEucG5n.jpg" /></strong></p>
<p><strong>1.3、网络通讯要素</strong></p>
<p><strong>IP地址：IPV4/IPV6</strong></p>
<p><strong>端口号:0-65535，一般0-1024，都被系统占用，mysql:3306,oracle:1521</strong></p>
<p><strong>传输协议:TCP/UDP</strong></p>
<h1><strong>二、</strong>类 InetAddress</h1>
<p><strong>2.1、InetAddress 主机对象</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTgwMjM4NDI5LTIwMzA0NzIyNTMucG5n.jpg" /></strong></p>
<p>IP 地址是 IP 使用的 32 位或 128 位无符号数字，它是一种低级协议，UDP 和 TCP 协议都是在它的基础上构建的</p>
<p><strong>2.2、示例</strong></p>
<pre>import java.net.*;
class IPDemo
{
    public static void main(String[] args) throws Exception
    {
        //getLoaclHostAddress();
        getAllByName();
    }
    /*
    获取本机的IP和主机名
    */
    public static void getLoaclHostAddress() throws Exception
    {
        //返回本地主机
        InetAddress ia=InetAddress.getLocalHost();
        System.out.println(ia.toString());
        //主机名
        String hostName=ia.getHostName();
        //IP地址
        String ip=ia.getHostAddress();
        System.out.println("hostName="+hostName+".....ip="+ip);
    }

    /*
    获取163或者百度的所有IP地址集合
    */
    public static void getAllByName() throws Exception
    {
        //获取淘宝的主机数组
        InetAddress [] ia=InetAddress.getAllByName("www.163.com");
        for(InetAddress i:ia)
        {
            //输出主机IP地址
            System.out.println("IP:"+i.getHostAddress());
            System.out.println("Name:"+i.getHostName());
        }
    }
}</pre>

<h1><strong>三、TCP与UDP</strong></h1>
<p>3.1、概述</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTgyMjI4MTYzLTE3NjM0MjI3NzkucG5n.jpg" /></p>
<h1><strong>四、Socket</strong></h1>
<p><strong>4.1、Socket</strong></p>
<p><strong>Socket就是为网络服务提供的一种机制</strong></p>
<p><strong>通信两端都有Socket</strong></p>
<p><strong>网络通信其实就是Socket间的通信</strong></p>
<p><strong>数据在两个Socket间通过IO通信</strong></p>
<p><strong>五、UDP</strong></p>
<p><strong>5.1、概述</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTg0MzAyNDEzLTIwNzY5NjkyMzkucG5n.jpg" /></strong></p>
<p>此类表示用来发送和接收数据报包的套接字。</p>
<table>
<tbody>
<tr>
<th colspan="2">构造方法摘要</th>
</tr>
<tr>
<td>&nbsp;</td>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramSocket</a></strong>()</code> <br />          构造数据报套接字并将其绑定到本地主机上任何可用的端口。</td>
</tr>
<tr>
<td><code>protected<br />
</code></td>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramSocket</a></strong>(<a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramSocketImpl</a> impl)</code></p>
<p>创建带有指定 DatagramSocketImpl 的未绑定数据报套接字。</td>
</tr>
<tr>
<td>&nbsp;</td>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramSocket</a></strong>(int port)</code></p>
<p>创建数据报套接字并将其绑定到本地主机上的指定端口。</td>
</tr>
<tr>
<td>&nbsp;</td>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramSocket</a></strong>(int port,<br />
<a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">InetAddress</a> laddr)</code></p>
<p>创建数据报套接字，将其绑定到指定的本地地址。</td>
</tr>
<tr>
<td>&nbsp;</td>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramSocket</a></strong>(<a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">SocketAddress</a> bindaddr)</code></p>
<p>创建数据报套接字，将其绑定到指定的本地套接字地址。</td>
</tr>
</tbody>
</table>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MTg0NDU2MDU0LTEzMTc1NDYyMy5wbmc=.jpg" /></p>
<p>此类表示数据报包。</p>
<p>数据报包用来实现无连接包投递服务。每条报文仅根据该包中包含的信息从一台机器路由到另一台机器。从一台机器发送到另一台机器的多个包可能选择不同的路由，也可能按不同的顺序到达。不对包投递做出保证。</p>
<table>
<tbody>
<tr>
<th colspan="2">构造方法摘要</th>
</tr>
<tr>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramPacket</a></strong>(byte[] buf, int length)</code> <br />          构造 <code>DatagramPacket</code>，用来接收长度为<br />
<code>length</code> 的数据包。</td>
</tr>
<tr>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramPacket</a></strong>(byte[] buf,<br />
int length, <a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">InetAddress</a> address, int port)</code></p>
<p>构造数据报包，用来将长度为 <code>length</code> 的包发送到指定主机上的指定端口号。</td>
</tr>
<tr>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramPacket</a></strong>(byte[] buf,<br />
int offset, int length)</code> <br />          构造<br />
<code>DatagramPacket</code>，用来接收长度为 <code>length</code><br />
的包，在缓冲区中指定了偏移量。</td>
</tr>
<tr>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramPacket</a></strong>(byte[] buf,<br />
int offset, int length, <a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">InetAddress</a> address, int port)</code></p>
<p>构造数据报包，用来将长度为 <code>length</code> 偏移量为 <code>offset</code><br />
的包发送到指定主机上的指定端口号。</td>
</tr>
<tr>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramPacket</a></strong>(byte[] buf,<br />
int offset, int length, <a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">SocketAddress</a> address)</code></p>
<p>构造数据报包，用来将长度为 <code>length</code> 偏移量为 <code>offset</code><br />
的包发送到指定主机上的指定端口号。</td>
</tr>
<tr>
<td><code><strong><a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">DatagramPacket</a></strong>(byte[] buf,<br />
int length, <a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">SocketAddress</a> address)</code></p>
<p>构造数据报包，用来将长度为 <code>length</code><br />
的包发送到指定主机上的指定端口号。</td>
</tr>
</tbody>
</table>
<p><strong>5.2、UDP发送端</strong></p>
<pre>/*
发送端
1.创建UDP服务，通过DatagramSocekt，
2.创建发送的数据，并封装为数据包，DatagramPacket
3.发送send
4.关闭DatagramSocekt资源
*/
import java.net.*;
class UdpSend
{
    public static void main(String[] args) throws Exception
    {
        //1.创建UDP服务，通过DatagramSocekt，
        DatagramSocket ds=new DatagramSocket();
        //2.创建发送的数据，并封装为数据包，DatagramPacket
        String say="udp数据!";
        byte [] buf = say.getBytes();
        InetAddress ia=InetAddress.getByName("localhost");
        int port =9898;
        DatagramPacket dp=new DatagramPacket(buf,buf.length,ia,port);
        //3.发送send
        ds.send(dp);
        //4.关闭DatagramSocekt资源
        ds.close();
    }
}</pre>
<p><strong>5.3、UDP接收端服务端</strong></p>
<pre>/*
接收端，服务端
1.创建UDP，Socket服务对象，DatagramSocket，设置商品
2.创建数据服包对象DatagramPacket包，接收数据报包
3.接收receive,到数据包在
4.通过数据报包，获取其中的数据如IP，数据和端口
5.解析数据转化为字符串,并打印
6.关闭资源
*/
import java.net.*;
class UdpReceive
{
    public static void main(String[] args)  throws Exception
    {
        //1.创建UDP，Socket服务对象，DatagramSocket，设置端口
        DatagramSocket ds=new DatagramSocket(9898);
        //2.创建数据服包对象DatagramPacket包，接收数据报包
        //接收内容的字节数据
        byte[] buf=new byte[1024];
        DatagramPacket dp=new DatagramPacket(buf,buf.length);
        //3.接收receive,到数据包在
        ds.receive(dp);
        //4.通过数据报包，获取其中的数据如IP，数据和端口
        //IPD
        String ip=dp.getAddress().getHostAddress();
        //主机名
        String hostname=dp.getAddress().getHostName();
        //数据
        String data=new String(dp.getData(),0,dp.getLength());
        //5.解析数据转化为字符串,并打印
        System.out.println(ip+":"+hostname+":"+data);
        //6.关闭资源
        ds.close();
    }
}</pre>
<p><strong>5.4、键盘录入</strong></p>
<pre>/*
发送端
键盘录入
*/
import java.net.*;
import java.io.*;
class UdpSend2
{
    public static void main(String[] args) throws Exception
    {
        //建立UDPSocket服务对象DatagramSocket
        DatagramSocket ds=new DatagramSocket();
        //主机对象
        InetAddress ia=InetAddress.getByName("localhost");
        int port=10001;
        //录入数据,字符流，键盘录入
        BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
        String line=null;
        while((line=br.readLine())!=null)
        {
            if("886".equals(line))
                break;
            //封装为数据报包
            byte [] buf=line.getBytes();
            DatagramPacket dp=new DatagramPacket(buf,buf.length,ia,port);
            //发送
            ds.send(dp);
        }
        //关闭
        br.close();
        ds.close();
    }
}</pre>
<pre>/*
接收端一直开启
*/
import java.net.*;
class UdpRece2
{
    public static void main(String[] args) throws Exception
    {
        //建立DatagramSocket对象服务，并指定端口
        DatagramSocket ds=new DatagramSocket(10001);
        while(true)
        {    //接收数据报包
            byte[] buf=new byte[1024];
            DatagramPacket dp=new DatagramPacket(buf,buf.length);
            //接收
            ds.receive(dp);
            //获取数据报中的数据
            String ip=dp.getAddress().getHostAddress();
            String data=new String(dp.getData(),0,dp.getLength());
            System.out.println(ip+":"+data);
        }
    }
}</pre>
<p><strong>5.5、示例</strong></p>
<pre>package com.pb.demo1;

/*
简单聊天工具
*/
//发送端
import java.net.*;
import java.io.*;
class Send implements Runnable
{
    private DatagramSocket ds;

    public  Send( DatagramSocket ds)
    {
        this.ds=ds;
    }
    //线程重写方法
    public void run()
    {
        try
        {//接收键盘录入
            BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
            InetAddress ia=InetAddress.getByName("192.168.2.255");
            int port =10002;
            String line=null;
            while ((line=br.readLine())!=null)
            {
                if("886".equals(line))
                    break;
                //封装数据
                byte[] buf=line.getBytes();
                DatagramPacket dp=new DatagramPacket(buf,buf.length,ia,port);
                //发送
                ds.send(dp);
            }
        }
        catch (Exception e)
        {
            throw new RuntimeException("发送失败!");
        }
    }

}
//接收端
class Rece implements Runnable
{
    private DatagramSocket ds;

    public  Rece( DatagramSocket ds)
    {
        this.ds=ds;
    }
    //线程重写方法
    public void run()
    {
        try
        {
           while (true)
            {
                //接收
                byte[] buf=new byte[1024];
                DatagramPacket dp=new DatagramPacket(buf,buf.length);
                ds.receive(dp);
                //通过数据报获取信息
                String ip=dp.getAddress().getHostAddress();
                String data=new String(dp.getData(),0,dp.getLength());
                //输出
                System.out.println(ip+":"+data);
            }
        }
        catch (Exception e)
        {
            throw new RuntimeException("接收失败!");
        }
    }

}
class ChatDemo
{
    public static void main(String[] args)  throws Exception
    {
        //发送
        DatagramSocket send=new DatagramSocket();
        //接收
        DatagramSocket rece=new DatagramSocket(10002);
        new Thread(new Send(send)).start();
        new Thread(new Rece(rece)).start();
    }
}</pre>

<h1><strong>六、TCP</strong></h1>
<p><strong>5.1、概述</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MjE0MTM0MTk0LTIwNDI4ODMzOTYucG5n.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MjE0MjQ2NzQxLTE2ODU2Nzc1OTgucG5n.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MjE0MzE1NTM4LTg5NTIwMTg2NS5wbmc=.jpg" /></strong></p>
<p><strong>5.2、TCP传输一次-简单使用</strong></p>
<pre>/*
TCP传输
1.TCP分客户端与服务端
2.客户端：Socket
   服务端：ServerSocket

*/
/*
客户端：
Socket()
          通过系统默认类型的 SocketImpl 创建未连接套接字
  Socket(InetAddress address, int port)
          创建一个流套接字并将其连接到指定 IP 地址的指定端口号。
  Socket(InetAddress host, int port, boolean stream)
          已过时。 Use DatagramSocket instead for UDP transport.
  Socket(InetAddress address, int port, InetAddress localAddr, int localPort)
          创建一个套接字并将其连接到指定远程地址上的指定远程端口。
  Socket(Proxy proxy)
          创建一个未连接的套接字并指定代理类型（如果有），该代理不管其他设置如何都应被使用。
protected  Socket(SocketImpl impl)
          使用用户指定的 SocketImpl 创建一个未连接 Socket。
  Socket(String host, int port)
          创建一个流套接字并将其连接到指定主机上的指定端口号。
  Socket(String host, int port, boolean stream)
          已过时。 使用 DatagramSocket 取代 UDP 传输。
  Socket(String host, int port, InetAddress localAddr, int localPort)
          创建一个套接字并将其连接到指定远程主机上的指定远程端口。
通过构造方法可以发现:
Socket对象，在建立时，就可以去连接指定主机
因为Tcp是面向连接的，所以在连接成功，形成通路后，
在该通道进行数据的传输
步骤：
1.创建客户端Socket服务，指定主机与端口
2.获取Socket流，socket.getXXX(InputStream或者OutputStream,并封装为字符流或者字节流
3.发送数据
4.关闭socket服务
*/
import java.net.*;
import java.io.*;
class  TcpClient
{
    public static void main(String[] args) throws Exception
    {
        //1.创建客户端Socket服务，指定主机与端口
        Socket s=new Socket("localhost",10003);
        //2.获取Socket流，socket.getXXX(InputStream或者OutputStream,并封装为字符流或者字节流
        OutputStream os=s.getOutputStream();
        //3.发送数据
        String say="Tcp客户端发送，测试数据!";
        os.write(say.getBytes());
        //4.关闭socket服务
        s.close();
    }
}
/*
步骤：
1.创建服务端Socket服务，指定端口
2.监听accept,并获取Socket流，没有连接，这个方法是阻塞工的
3.获取对应客户端对象的socket.getXXX(InputStream或者OutputStream,并封装为字符流或者字节流
4.接收数据InptuStream或者发送OutputStream
5.打印
6.(可选一般不关闭)关闭socket服务
*/
class TcpServer
{
    public static void main(String[] args) throws Exception
    {
        //1.创建服务端Socket服务，指定端口
        ServerSocket ss=new ServerSocket(10003);
        //2.监听accept,并获取Socket流，没有连接，这个方法是阻塞工的
        Socket s=ss.accept();
        //3.获取对应客户端对象的socket.getXXX(InputStream或者OutputStream,并封装为字符流或者字节流
        //4.接收数据InptuStream或者发送OutputStream
        InputStream is=s.getInputStream();

        //获取客户端IP
        String ip=s.getInetAddress().getHostAddress();

        //设置缓冲区
        byte[] buf=new byte[1024];
        //把数据读取到缓冲区中
        int  len=is.read(buf);
        //转换为字符串
        String data=new String(buf,0,len);
        //5.打印
        System.out.println(ip+"........");
        System.out.println(data);

        //6.(可选一般不关闭)关闭socket服务
        s.close();
        ss.close();

    }
}</pre>
<p><strong>5.3、SocetKet接收与返回</strong></p>
<pre>/*
客户端给服务端发送数据
服务端收到后给客户端反馈信息
客户接收反馈数据
*/

/*步骤：
1.创建客户端Socket服务，指定主机与端口
2.获取Socket流，socket.getXXX(InputStream或者OutputStream,并封装为字符流或者字节流
3.发送数据
4.关闭socket服务
*/
import java.net.*;
import java.io.*;
class TcpClient2
{
    public static void main(String[] args) throws Exception
    {
        //1.建立Socekt服务并指定端口
        Socket s=new Socket("localhost",10004);
        //2.信息
        String sendInfo="客户端发送的信息!";
        //3.获取输出流写到服务端
        OutputStream os=s.getOutputStream();
        os.write(sendInfo.getBytes());
        //4.获取输入信息接收服务端信息
        InputStream is=s.getInputStream();
        byte [] buf=new byte[1024];
        int len=is.read(buf);
        String rev=new String(buf,0,len);
        System.out.println("服务端反馈的信息："+rev);
        s.close();
    }
}
/*
步骤：
1.创建服务端Socket服务，指定端口
2.监听accept,并获取Socket流，没有连接，这个方法是阻塞工的
3.获取对应客户端对象的socket.getXXX(InputStream或者OutputStream,并封装为字符流或者字节流
4.接收数据InptuStream或者发送OutputStream
5.打印
6.(可选一般不关闭)关闭socket服务
*/
class TcpServer2
{
    public static void main(String[] args) throws Exception
    {
        //建立服务端ServerSocket数据
        ServerSocket ss=new ServerSocket(10004);
        //获取客户端对象accept,
        Socket s=ss.accept();
        //获取输入流对象接收客户端信息
        InputStream is=s.getInputStream();
        //建立缓冲区
        byte []     buf=new byte[1024];
        int len=is.read(buf);
        String clientInfo=new String(buf,0,len);
        //获取IP
        String ip=s.getInetAddress().getHostAddress();
        System.out.println(ip+"....."+clientInfo);
        //返回给客户端的信息
        String rel="已经收到了";
        //获取输出流对象
        OutputStream os=s.getOutputStream();
        os.write(rel.getBytes());
        //关闭 可选
        s.close();
        ss.close();
    }
}</pre>
<p><strong>5.4、综合</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcxMDcxNS8yMDE1MTAvNzEwNzE1LTIwMTUxMDE3MjMzNTIyMzA0LTEyNTc4MTk0MDkucG5n.jpg" /></strong></p>
<pre>/*
建立一个转换服务器
客户端输入内容到服务器，服务把内容转成大写再返回给客户端
客户端可以 不断的进行文本输入，
当客户端输入over时结束
*/
/*
客户端
操作设备上的数据，可以使用IO技术
并按照IO的操作规律来完成
源：键盘录入
目的：网络设置，网络输出
而且操作的是文本数据，可以选择
字符流与字符缓冲流
*/
import java.io.*;
import java.net.*;
class  TcpClient3
{
    public static void main(String[] args) throws Exception
    {
        //建立服务
        Socket s=new Socket("localhost",10005);
        //获取键盘录入
        BufferedReader br=
            new BufferedReader(new InputStreamReader(System.in));
        //目的发送给服务端
        //BufferedWriter bwOut=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
        //打印流，可以接收字符流、缓冲流、字节流，第二个参数true表示自动刷新
        PrintWriter out=new PrintWriter(s.getOutputStream(),true);
        //获取服务端返回的信息
        BufferedReader brIn=
            new BufferedReader(new InputStreamReader(s.getInputStream()));
        //键盘录入数据
        String line=null;
        //服务端返回数据
        String recLine=null;
        //接收键盘录入
        while((line=br.readLine())!=null)
        {
            if("over".equals(line))
                break;
            out.println(line);
            /*
            //将信息写入服务端
            bwOut.write(line);
            //增加换行
            bwOut.newLine();
            //刷新缓冲区
            bwOut.flush();
            */

        //获取取服务端返回的大写数据
            recLine=brIn.readLine();
        System.out.println("服务器返回信息："+recLine);
        }
        //结束，关资源
        s.close();

    }
}
/*
服务器
*/
class  TcpServer3
{
    public static void main(String[] args) throws Exception
    {
        //建立服务端对象
        ServerSocket ss=new ServerSocket(10005);
        //获取客户端Socket对象
        Socket s=ss.accept();
        String ip=s.getInetAddress().getHostAddress();
        System.out.println(ip+"....");
        //获取客户端流对象
        BufferedReader brIn=
            new BufferedReader(new InputStreamReader(s.getInputStream()));

        //BufferedWriter bwOut=new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
        //打印流，可以接收字符流也可以接收字节流，加true自动刷新
        PrintWriter out=new PrintWriter(s.getOutputStream(),true);
        String line=null;
        while((line=brIn.readLine())!=null)
        {
            System.out.println("客户端说："+line);
            out.println(line.toUpperCase());
            /*
            //转换为大写返回客户端
            bwOut.write(line.toUpperCase());
            //增加换行
            bwOut.newLine();
            //刷新缓冲区
            bwOut.flush();
            */
        }
        s.close();
        ss.close();
    }
}
/*
问题：
客户端和服务端都在莫名的等待
因为客户端和服务端都在阻塞的方法，
这些方法没有读到结束标记，那么就一直等待
而导致两端，都在等待
*/</pre>
<p><strong>5.5、示例-TCP文件复制</strong></p>
<pre>/*
上传一个文件到服务器
*/
import java.net.*;
import java.io.*;
/*
客户端
*/
class UploadClient
{
    public static void main(String[] args) throws Exception
    {
        //建立客户端服务
        Socket s=new Socket("localhost",10009);
        //上传文件
        File file=new File("d:\\gm.mp3");
        //获取文件名
        String filename=file.getName();
        //建立基本数据流将文件名发送过去
        PrintWriter pw=new PrintWriter(s.getOutputStream(),true);
        //发送
        pw.println(filename);
        //建立输入流
        FileInputStream fis=new FileInputStream(file);
        BufferedInputStream bis=new BufferedInputStream(fis);
        //建立流输出
        BufferedOutputStream bos=new BufferedOutputStream(s.getOutputStream());
        //建立字符缓冲，接收服务端返回的提示信息
        BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
        int len=0;
        while((len=bis.read())!=-1)
        {
            bos.write(len);
            bos.flush();
        }
        //关闭输出流，增加结束标记
        s.shutdownOutput();
        String str=br.readLine();
        System.out.println(str);
        bis.close();
        fis.close();
        s.close();

    }
}
/*
服务端
*/
class UploadServer
{
    public static void main(String[] args) throws Exception
    {
        //建立服务
        ServerSocket ss=new ServerSocket(10009);
        //获取客户端对象
        Socket s=ss.accept();
        //获取客户端 发送的文件名
        BufferedReader br=new BufferedReader(new InputStreamReader(s.getInputStream()));
        String filename=br.readLine();
        System.out.println("文件名："+filename);
        //文件输读流
        BufferedInputStream bis=new BufferedInputStream(s.getInputStream());
        //文件输出流
        File f=new File("f:\\",filename);
        BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(f));
        //输出提示信息
        PrintWriter pw=new PrintWriter(s.getOutputStream(),true);
        int len=0;
        while((len=bis.read())!=-1)
        {
            bos.write(len);
            bos.flush();
        }
        pw.println("上传成功");
        bos.close();
        s.close();
        ss.close();

    }
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 15:13:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>JAVA基础学习day24--Socket基础一UDP与TCP的基本使用的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rbVGq3.html" rel="bookmark">Java培训学习需要什么基础？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着互联网的飞速发展,其对相关人才的需求更是不断增加.高薪资高待遇吸引不少其它行业的人员也投身于此.作为最受企业欢迎Java语言,更是备受学员青睐.来千锋报名学习Java的不少学员都会问到同一个问题,学Java需要什么基础? 在回答这个问题前,我们先来简单的了解一下Java语言. Java是一种可以撰写跨平台应用程序的面向对象的程序设计语言.Java 技术具有卓越的通用性.高效性.平台移植性和安全性,广泛应用于PC.数据中心.游戏控制台.科学超级计算机.移动电话和互联网,同时拥有全球最大的开发者			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6gKq50.html" rel="bookmark">python3基础学习笔记（基础知识）-01</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python的基础学习: 数据类型:python是弱类型语言,在定义变量的时候,可以不直接制定数据类型. 1.Numbers: int 有符号整型    a = (-1)  a = 1 long 长整型 float 浮点型 complex 复数 2.boolean: True    Flase 3.String :字符串   a = &quot;Hello World&quot; 4.List :列表 有序  list1 = [] 5.Tuple : 元组  定义后不能被修改  a = (1,2,3) 6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPgkWP4.html" rel="bookmark">Java基础学习第二天&mdash;&mdash;基础数据类型介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文档版本 开发工具 测试平台 工程名字 日期 作者 备注 V1.0 2016.02.21 lutianfei none 第二章 Java基础语法 本章内容 关键字 标识符 注释 常量.进制和进制转换 变量 数据类型和类型转换 运算符 语句 (一)关键字 关键字概述 被Java语言赋予特定含义的单词 关键字特点 组成关键字的字母全部小写 关键字注意事项 goto和const作为保留字存在,目前并不使用(在JDK的新版本中可能提升为关键字) (二)标识符 标识符概述 就是给类,接口,方法,变量等起名			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r0arDE3.html" rel="bookmark">java基础学习05&lpar;面向对象基础01--类实例分析&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面向对象基础01(类实例分析) 实现的目标 1.如何分析一个类(类的基本分析思路) 分析的思路 1.根据要求写出类所包含的属性2.所有的属性都必须进行封装(private)3.封装之后的属性通过setter和getter设置和取得4.如果需要可以加入若干构造方法 5.再根据其它要求添加相应的方法6.类中的所有方法都不要直接输出,而是交给被调用处调用 Demo 定义并测试一个名为Student的类,包括属性有&quot;学号&quot;.&quot;姓名&quot;以及3门课程&quot;数学&quot;.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49rYaXM.html" rel="bookmark">java基础学习05&lpar;面向对象基础02&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面向对象基础02 实现的目标 1.String类的使用 2.掌握this关键字的使用3.掌握static关键字的使用 String类 实例化String对象一个字符串就是一个String类的匿名对象,就是已经开辟了堆内存空间的并可以直接使用的对象.1.采用直接赋值的方式进行操作. String name = &quot;zhangsan&quot;; 使用这种方式,如果一个字符串已经被一个名称所引用,则以后再有相同的字符串声明时,就不会再开辟内存空间.2.直接调用String类的构造方法(public S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Aevwa4.html" rel="bookmark">JAVA基础-学习总结-语法基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标识符的概念和命名规则 JAVA常量---不可变的变量 程序的执行过程 从现在开始,你应该记住,内存里分四块区域,code segment,data segment,stack,heap,真正执行的时候,代码首先放到code segment里面,虚拟机找到相关的main方法,然后开始噼里啪啦噼里啪啦的执行,在执行的过程中,会牵扯到其他三块内存区域.因为执行的时候需要在不同的区域分配内存. JAVA变量 1,java中的变量是程序中最小的存储单元,其要素包括变量名,变量类型,作用域. 2,java			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZwYOm4.html" rel="bookmark">吴裕雄--天生自然 JAVA开发学习：Applet 基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				import java.applet.*; import java.awt.*; public class HelloWorldApplet extends Applet { public void paint (Graphics g) { g.drawString (&quot;Hello World&quot;, 25, 50); } } &lt;html&gt; &lt;title&gt;The Hello, World Applet&lt;/title&gt; &lt;hr&gt; &lt;app			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mynp2n0.html" rel="bookmark">JavaScript基础学习总结2 基础部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.JS 命名规范 命名规范是很有必要的,可增强代码的可读性,一眼就能看懂要表达的意思,规范就是符合规则,使代码有利于后期维护,也能很大程度的提高开发效率.一个正常的网站有很多 JS 代码,如果在编写的过程中,不遵循某种规则,那么写到后面自己都看不懂自己写的什么,这是很麻烦的一件事,所以要在平时的练习过程中,养成良好的编写代码的习惯. 一般都采用匈牙利命名法或者驼峰命名法. 匈牙利命名法的原则:变量名=属性+类型+对象描述.他的关键是:以一个或多个小写字母作为前缀,前缀之后是一个或多个首字母大写			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KBbmKM.html" rel="bookmark">python基础学习笔记&mdash;&mdash;Python基础教程&lpar;第2版 修订版&rpar;第十章（充电时刻）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#模块 #包 #模块中有什么 dir l列出特性 #文档 print range.__doc__ #阅读源代码 print copy.__file__ #标准库 sys os fileinput #集合,堆和双端队列 set(range(10)) 集合 堆 数据结构 没有独立的 只有一个包含一些堆操作的模块,叫做heapq(6个函数) 双端队列 #time #random #shelve #re #包含对正则表达式的支持			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoLVwB0.html" rel="bookmark">python基础学习笔记&mdash;&mdash;Python基础教程&lpar;第2版 修订版&rpar;第八章（异常）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#异常 类 #捕捉 try try: x=input(sds) y=input(sd) print x/y except ZeroDivisionError print(0sdf) except TypeErrpr except (ZeroDivisionError,TYpeError) #捕捉对象 except(Zerosion.)as e: print(e) #finally			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXj1Q3.html" rel="bookmark" class="title">关于FEer发展方向的思考</a>
					<div>
						今天学习了HTTP权威指南这本书,虽然标题是对FEer发展的思考,不过我打算稍后再说这个议题,先对今天学习的内容做个总结. 首先:原来访问服务器的方式有多重,核心是URI,也就是统一资源定位,按照访问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYdxZ0.html" rel="bookmark" class="title">第三章 控制程序流程</a>
					<div>
						一.使用Java运算符 1.优先序 2.赋值.指派 3.数学运算符 4.递增和递减 5.关系运算符 6.逻辑运算符 当整个表达式可以被确切的判断出真伪时,表达式的评估动作便会结束(短路式核定) 7.位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418mXv3.html" rel="bookmark" class="title">hdu 5030 Rabbit&amp;&num;39&semi;s String&lpar;后缀数组&rpar;</a>
					<div>
						题目链接:hdu 5030 Rabbit's String 题目大意:给定k和一个字符串,要求将字符串拆分成k个子串.然后将每个子串中字典序最大的子串选出来,组成一个包含k个字符串的集合,要求这个集合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRdwj4.html" rel="bookmark" class="title">or1200中乘法除法指令说明</a>
					<div>
						以下内容摘自&lt;步步惊芯--软核处理器内部设计分析&gt;一书 OR1200中乘法除法类指令共有9条,表8.3给出了所有的乘法除法类指令的作用及说明. 说明:表8.3是ORBIS32中给出的指令用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAWl63.html" rel="bookmark" class="title">跳棋算法策略</a>
					<div>
						棋子跳动算法该算法在ChessBoard.CanJumpTo函数中实现 ? 找出一个棋子所有可走位置,并建成数据结构&quot;图&quot;的形式这个算法有点象图的广度优先遍历算法.文字说明如下:1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZvzj3.html" rel="bookmark" class="title">hdu 5446 Unknown Treasure 卢卡斯&plus;中国剩余定理</a>
					<div>
						Unknown Treasure Time Limit: 1500/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Other ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomPvQ3.html" rel="bookmark" class="title">Selenium2Library系列 keywords 之 &lowbar;SelectElementKeywords 之 unselect&lowbar;from&lowbar;list&lowbar;by&lowbar;index&lpar;self&comma; locator&comma; &ast;indexes&rpar;</a>
					<div>
						1 def unselect_from_list_by_index(self, locator, *indexes): 2 &quot;&quot;&quot;Unselects `*indexes` ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZPG13.html" rel="bookmark" class="title">用户体验五要素</a>
					<div>
						一.战略层:企业与用户对产品的期望和目标.(做什么,为谁而做?) 二.范围层:功能及其内容需求整合.(需要做哪些?) 1. 产品功能的确定.收集功能需求—&gt;为需求定义优先级 2.需求的三个主要类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvWKD3.html" rel="bookmark" class="title">监听Android的Home键碰到的问题</a>
					<div>
						Android的TV监听Home键切换信源碰到的问题 实现的功能是按下Home键,焦点放到TV小窗口上,再次按下Home键,切换信源,进入另一个信源.在另一个信源的显示下,按下Home键,原信源视图缩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvpoQ3.html" rel="bookmark" class="title">select 函数 实现三个客户端异步通信</a>
					<div>
						1 //建立管道 2 mkfifo 12 13 21 23 31 32 open 顺序: cl1 读 , cl2 cl3 向 cl1写 cl2 读 , cl1 cl3 向 cl2写 cl3 读 , c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLADJ4.html" rel="bookmark" class="title">freemarker标签大全</a>
					<div>
						FreeMarker的插值有如下两种类型:1,通用插值${expr};2,数字格式化插值:#{expr}或#{expr;format} ${book.name?if_exists }  //用于判断如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAOyA3.html" rel="bookmark" class="title">PHP课程总结20161219</a>
					<div>
						今天的课程,老师主要介绍了变量作用域的相关内容,以及几种函数(function)的用法. 一.总结 1.全局变量:定义在函数外面的变量.在函数(function)中使用,需要声明它是全局变量,方法:g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJRmD3.html" rel="bookmark" class="title">使用python的zabbix&lowbar;api模块</a>
					<div>
						使用python的zabbix_api模块,以下是简单的zabbix api的使用 zabbix api文档参考https://www.zabbix.com/documentation/2.2/man ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8kO93.html" rel="bookmark" class="title">django之定义模板语法02（for语句循环list数据）</a>
					<div>
						1.定义index页面 &lt;html&gt; &lt;head&gt; &lt;title&gt;DOcument&lt;/title&gt; &lt;/head&gt; &lt;body&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJo5v3.html" rel="bookmark" class="title">&lpar;四&rpar; 一起学 APUE 之 系统数据文件和信息</a>
					<div>
						. . . . . 目录 (一) 一起学 APUE 之 标准 IO (二) 一起学 APUE 之 文件 IO (三) 一起学 APUE 之 文件和目录 (四) 一起学 APUE 之 系统数据文件和信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBN913.html" rel="bookmark" class="title">修改虚拟机镜像的root密码</a>
					<div>
						有时从网上下载的虚拟机镜像,没有root密码,必须通过秘钥登录,然后秘钥又需要麻烦的注入到里面去.想用,却无法登录,很头痛.本文提供一种通过修改虚拟机镜像里面的/etc/shadow文件,来设置镜像的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXev1M.html" rel="bookmark" class="title">div float</a>
					<div>
						&lt;html&gt; &lt;head&gt; &lt;/head&gt; &lt;body&gt; &lt;div style=&quot;width:200px; overflow:hidde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME1QoDM.html" rel="bookmark" class="title">基于JQuery实现的幻灯片轮播（对时间间隔做严格控制）</a>
					<div>
						&lt;div class=&quot;tel_slide&quot;&gt; &lt;div class=&quot;tel_slide_title&quot;&gt;Title&lt;/div&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qv1qeM.html" rel="bookmark" class="title">js删除局部变量的实现方法</a>
					<div>
						lert('value:'+str+'\ttype:'+typeof(str)) //声明变量前,引用 var str=&quot;dd&quot;; alert('value:'+str+'\tty ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLpZ7EM.html" rel="bookmark" class="title">汽车预约维修系统软件开发</a>
					<div>
						维修汽车预约软件定制开发 陈琦 138-2848-7919可微:汽车维修预约门店软件定制开发. 被动预约一般按来电预约内容分为,一般维修预约.汽车保养预约.汽车理赔预约,汽车主动预约一般按你所主动联系 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
